package com.one;

/**
 * Класс для обработки текста
 */
public class TextProcessor
{
	/**
	 * Замена в строке экранированных символов их значениями.
	 *
	 * Распознаются как буквенные сочетания вроде CR, LF и TAB,
	 * так и октальные и юникодовые.
	 */
	public static String unescapeString(String text)
	{
		StringBuffer res = new StringBuffer(text.length());
		int index, subindex, rc;
		char c;

		while(text.length() > 0)
		{
			index = text.indexOf('\\');

			if(index >= 0)
			{
				res.append(text.substring(0, index));

				c = Character.toLowerCase(text.charAt(++index));
				subindex = "bfnrt\\".indexOf(c);

				if(subindex >= 0)
				{
					res.append("\b\f\n\r\t\\".charAt(subindex));
					text = text.substring(index + 1);
				}
				else if(c == 'u')
				{
					index++;
					rc = 0;

					for(int i = 0; i < 4 && index < text.length(); i++)
					{
						subindex = "0123456789ABCDEF".indexOf(Character.toUpperCase(text.charAt(index++)));

						if(subindex >= 0)
						{
							rc = (rc << 4) | subindex;
						}
						else
						{
							break;
						}
					}

					res.append((char)rc);
					text = text.substring(index);
				}
				else
				{
					rc = 0;

					for(int i = 0; i < 3 && index < text.length(); i++)
					{
						subindex = "01234567".indexOf(text.charAt(index++));

						if(subindex >= 0)
						{
							rc = (rc << 3) | subindex;
						}
						else
						{
							break;
						}
					}

					res.append((char)rc);
					text = text.substring(index);
				}
			}
			else
			{
				res.append(text);
				break;
			}
		}

		return res.toString();
	}
}
